//+------------------------------------------------------------------+
//|                                      ManualOrderManager_v7_1.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

extern double LotSize=5.0;
extern bool OpenHigh=true;
extern bool OpenLow=true;
extern int  StartHour=12;
extern int Shift=1;
extern int magicnumber=0;

extern int SL = 25;
extern int TP = 50;
extern int BreakEvenAt = 25;
extern int TrailingStop = 35;
extern color LongTPColour = Lime;
extern int LongTPWidth = 1;
extern int LongTPStyle = 2;
extern color LongSLColour = Red;
extern int LongSLWidth = 1;
extern int LongSLStyle = 2;
extern color ShortTPColour = Lime;
extern int ShortTPWidth = 1;
extern int ShortTPStyle = 2;
extern color ShortSLColour = Red;
extern int ShortSLWidth = 1;
extern int ShortSLStyle = 2;
extern bool CloseHalfLots=true;
extern color CloseHalfLotsColour = Yellow;
extern int CloseHalfLotsWidth = 1;
extern int CloseHalfLotsStyle = 2;


extern bool AlarmStopLoss=true;
extern bool AlarmTrailStop=true;
extern bool AlarmBreakeven=true;
extern bool AlarmHalfTP=true;
extern bool AlarmTP=true;


double Lots=0;
double sl,tp,htp;
int os=0;
int adj, TrailingStep = 1;
int OrdersHalfClosedTicket[500];
double OrdersHalfClosedLots[500];
int PRESLIPPAGE=80,SLIPPAGE=0;
double RealPoint=0;
int orderscontrol=0;
int trailingstopflag=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(Digits == 3 || Digits == 5){adj = 10;}else {adj = 1;}
   
   Lots=LotSize;

   if (Digits==3 || Digits==5)
   {
      RealPoint=Point*10;
      SLIPPAGE=PRESLIPPAGE*10;
   }
   else
   {
      RealPoint=Point;
      SLIPPAGE=PRESLIPPAGE;
   }
   
   InitializeBuffers();
   
   trailingstopflag=TrailingStop;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll();
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
      bool IsTradeHour=false;
      if(TimeHour(Time[0]) >= StartHour){IsTradeHour=true;}
 
      if(Lots<MarketInfo(Symbol(),MODE_MINLOT))
      {
         Alert("Number of Lots is not permitted.Please Change de Lots value in the Expert Properties page.");
         Sleep(60000);
         return(0);
      }
      
      if(orderscontrol==0 && IsTradeHour)
         SendOrders();
      
      CO();
      
      if(CloseHalfLots==true)
      {
         InitializeBuffers();
         CHLO();
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+

void SendOrders()
{  
   if(TotalOrders()>0)
      return(0);
   
   int LongType=0,ShortType=0;
   if(OpenHigh==false && OpenLow==false)
      return(0);
      
   if(OpenHigh==true)
   {
      if(Ask<High[Shift]+RealPoint)
         LongType=OP_BUYSTOP;
      else
         LongType=OP_BUYLIMIT;
      
      while(IsTradeContextBusy()==false)
      {
         RefreshRates();
         os=OrderSend(Symbol(),LongType,Lots,High[Shift]+RealPoint,SLIPPAGE,0,0,NULL,magicnumber,0,Blue);
         break;
      }
      if(os==-1)
      {
         Alert("Error:"+GetLastError());
      }
      orderscontrol=1;
   }
   
   if(OpenLow==true)
   {
      if(Bid<Low[Shift]-RealPoint)
         ShortType=OP_SELLLIMIT;
      else
         ShortType=OP_SELLSTOP;
      
      while(IsTradeContextBusy()==false)
      {
         RefreshRates();
         os=OrderSend(Symbol(),ShortType,Lots,Low[Shift]-RealPoint,SLIPPAGE,0,0,NULL,magicnumber,0,Red);
         break;
      }
      if(os==-1)
      {
         Alert("Error:"+GetLastError());
      }
      orderscontrol=1;
   }
   
   
   
   
   return(0);
}


int TotalOrders()
{
   int orders=OrdersTotal();
   int totalord=0;
   
   if(orders==0)
   {
      return(0);
   }
   else
   {
      for(;orders>=0;orders--)
      {
         RefreshRates();
         OrderSelect(orders,SELECT_BY_POS);
         if(OrderMagicNumber()==magicnumber && OrderSymbol()==Symbol())
         {
            totalord++;
         }
      }
   }
   return(totalord);
}



void InitializeBuffers()
{
   for(int f = 0; f < OrdersTotal();f++)
   {
      OrderSelect(f,SELECT_BY_POS,MODE_TRADES);

      if(OrderMagicNumber() == magicnumber && OrderSymbol() == Symbol())
      {
         OrdersHalfClosedTicket[f]=OrderTicket();
         OrdersHalfClosedLots[f]=OrderLots();
      }
   }  
}


int CO()// manage orders
{
   int c = 0;
   for(int f = 0; f < OrdersTotal();f++)
   {
      OrderSelect(f,SELECT_BY_POS,MODE_TRADES);

      if(OrderMagicNumber() == magicnumber && OrderSymbol() == Symbol())
      {
         c++;
         if( OrderType() == OP_BUY )
         {
            sl = OrderOpenPrice()-fx(SL);
            tp = OrderOpenPrice()+fx(TP);
            //htp= OrderOpenPrice()+fx(TP)/2;
            
            if(gl("SL"+OrderTicket())>0)sl = gl("SL"+OrderTicket());
            if(gl("TP"+OrderTicket())>0)tp = gl("TP"+OrderTicket());
            //if(gl("HC"+OrderTicket())>0)htp = gl("HC"+OrderTicket());

            if(BreakEvenAt > 0 && Bid - OrderOpenPrice() > fx(BreakEvenAt) && sl < OrderOpenPrice())
            {
               sl = OrderOpenPrice();
               if(AlarmBreakeven)
                  PlaySound("Breakeven.wav");
            }
            if(trailingstopflag > 0 && Bid - OrderOpenPrice()> fx(trailingstopflag) && sl < Bid -(fx(trailingstopflag)+fx(TrailingStep)-fx(1)) ) 
            {
               sl = Bid-fx(trailingstopflag);
               tp = sl+fx(SL+TP); 
               //if(CloseHalfLots==true)
                 // htp=OrderOpenPrice()+(tp-OrderOpenPrice())/2;
               if(AlarmTrailStop)
                  PlaySound("Wait.wav");
            }
            
            SetLine("SL"+OrderTicket(),sl,LongSLColour,LongSLWidth,LongSLStyle);
            ObjectSetText("SL"+OrderTicket(),"SL"+OrderTicket());
            SetLine("TP"+OrderTicket(),tp,LongTPColour,LongTPWidth,LongTPStyle);
            ObjectSetText("TP"+OrderTicket(),"TP"+OrderTicket());
            
            /*if(CloseHalfLots==true)
            {
               SetLine("HC"+OrderTicket(),htp,CloseHalfLotsColour,CloseHalfLotsWidth,CloseHalfLotsStyle);
               ObjectSetText("HC"+OrderTicket(),"HC"+OrderTicket());
            }*/

            if(Bid >= tp || Bid <= sl)OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE);
            if(Bid>=tp && AlarmTP)
               PlaySound("Alert.wav");
            if(Bid<=sl && AlarmStopLoss)
               PlaySound("Assembly.wav");          
         }
         if( OrderType() == OP_SELL )
         {
            sl = OrderOpenPrice()+fx(SL);
            tp = OrderOpenPrice()-fx(TP);
            //htp= OrderOpenPrice()-fx(TP)/2;
            
            if(gl("SL"+OrderTicket())>0)sl = gl("SL"+OrderTicket());
            if(gl("TP"+OrderTicket())>0)tp = gl("TP"+OrderTicket());
            //if(gl("HC"+OrderTicket())>0)htp = gl("HC"+OrderTicket());


            if(BreakEvenAt > 0 && OrderOpenPrice()-Ask > fx(BreakEvenAt) && sl > OrderOpenPrice())
            {
               sl = OrderOpenPrice();
               if(AlarmBreakeven)
                  PlaySound("Breakeven.wav");
            }
            
            if(trailingstopflag > 0 && OrderOpenPrice()-Ask > fx(trailingstopflag) && sl > Ask+(fx(trailingstopflag)+fx(TrailingStep)-fx(1)) ) 
            {
              sl = Ask+fx(trailingstopflag);
              tp = sl-fx(SL+TP); 
              //if(CloseHalfLots==true)
                //  htp=OrderOpenPrice()-(OrderOpenPrice()-tp)/2; 
              if(AlarmTrailStop)
                  PlaySound("Wait.wav");
            }

            SetLine("SL"+OrderTicket(),sl,ShortSLColour,ShortSLWidth,ShortSLStyle);
            ObjectSetText("SL"+OrderTicket(),"SL"+OrderTicket());
            SetLine("TP"+OrderTicket(),tp,ShortTPColour,ShortTPWidth,ShortTPStyle);
            ObjectSetText("TP"+OrderTicket(),"TP"+OrderTicket());
            
            /*if(CloseHalfLots==true)
            {
               SetLine("HC"+OrderTicket(),htp,CloseHalfLotsColour,CloseHalfLotsWidth,CloseHalfLotsStyle);
               ObjectSetText("HC"+OrderTicket(),"HC"+OrderTicket());
            }*/

            if(Ask <= tp || Ask >= sl)OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE);
            
            if(Ask<=tp && AlarmTP)
               PlaySound("Alert.wav");
            if(Ask>=sl && AlarmStopLoss)
               PlaySound("Assembly.wav"); 
         }
      }
   }  
   
   for(int z = 0; z < OrdersHistoryTotal();z++)
   {
      OrderSelect(z,SELECT_BY_POS,MODE_HISTORY);
      if(OrderMagicNumber() == magicnumber && OrderSymbol() == Symbol())
      {
         if(gl("SL"+OrderTicket())>0)ObjectDelete("SL"+OrderTicket());
         if(gl("TP"+OrderTicket())>0)ObjectDelete("TP"+OrderTicket());
         if(gl("HC"+OrderTicket())>0)ObjectDelete("HC"+OrderTicket());
      } 
   }

   return(c);    
}


void CHLO()
{     
   for(int f = 0; f < OrdersTotal();f++)
   {
      OrderSelect(f,SELECT_BY_POS,MODE_TRADES);
      
      if(OrderMagicNumber() == magicnumber && OrderSymbol() == Symbol())
      {
         if(OrderHalfClosed(OrderTicket(),Lots)) continue;
         
         if( OrderType() == OP_BUY )
         {
            htp = OrderOpenPrice()+fx(TP)/2;
            if(gl("HC"+OrderTicket())>0)htp = gl("HC"+OrderTicket());
            if(Bid >= htp && OrderLots()>=2*MarketInfo(Symbol(),MODE_MINLOT))
            {
               OrderClose(OrderTicket(),OrderLots()/2,Bid,0,CLR_NONE);
               trailingstopflag=TrailingStop/2;
               //OrdersHalfClosedTicket[f]=OrderTicket();
               if(AlarmHalfTP)
                  PlaySound("HalfProfit.wav");
            }
            SetLine("HC"+OrderTicket(),htp,CloseHalfLotsColour,CloseHalfLotsWidth,CloseHalfLotsStyle);
            ObjectSetText("HC"+OrderTicket(),"HC"+OrderTicket());
         }
         if( OrderType() == OP_SELL )
         {
            htp = OrderOpenPrice()-fx(TP)/2;
            if(gl("HC"+OrderTicket())>0)htp = gl("HC"+OrderTicket());
            if(Ask <= htp && OrderLots()>=2*MarketInfo(Symbol(),MODE_MINLOT))
            {
               OrderClose(OrderTicket(),OrderLots()/2,Ask,0,CLR_NONE);
               trailingstopflag=TrailingStop/2;
               //OrdersHalfClosedTicket[f]=OrderTicket();
               if(AlarmHalfTP)
                  PlaySound("HalfProfit.wav");
            }
            SetLine("HC"+OrderTicket(),htp,CloseHalfLotsColour,CloseHalfLotsWidth,CloseHalfLotsStyle);
            ObjectSetText("HC"+OrderTicket(),"HC"+OrderTicket());
         }
      }
   }  
   return(0);    
}

bool OrderHalfClosed(int ticket, double lots)
{  
    for(int f = 0; f < OrdersTotal();f++)
   {
      OrderSelect(f,SELECT_BY_POS,MODE_TRADES);
      
      if(OrderMagicNumber() == magicnumber && OrderSymbol() == Symbol())
      {
         if(OrderLots()==lots)
            return(false);
         
      }
   }
   return(true); 
}



//+------------------------------------------------------------------+
void SetLine(string ln, double lp, color lc, int lw, int ls)
{
   if(ObjectFind(ln) < 0)
   {
      ObjectCreate(ln,OBJ_HLINE,0,0,lp);
   }
   else
   {
      ObjectSet(ln,OBJPROP_PRICE1,lp);
      ObjectSet(ln,OBJPROP_COLOR,lc);
      ObjectSet(ln,OBJPROP_WIDTH,lw);
      ObjectSet(ln,OBJPROP_STYLE,ls);
   }
}
//+------------------------------------------------------------------+
double gl(string nnn)// return point value
{
   return(ObjectGet(nnn,OBJPROP_PRICE1));
}
//+------------------------------------------------------------------+
double fx(int nnn)// return point value
{
   return((nnn*adj)*Point);
}
//+------------------------------------------------------------------+